Package ej.mwt.style.dimension

## Class OptimalDimension

- java.lang.Object
- - ej.mwt.style.dimension.OptimalDimension

- All Implemented Interfaces:
    `Dimension`

      public class OptimalDimension
      extends Object
      implements Dimension

  Dimension which fits the optimal size of the widget.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static OptimalDimension` | `OPTIMAL_DIMENSION_X` | Optimal dimension using widget's optimal width.
    `static OptimalDimension` | `OPTIMAL_DIMENSION_XY` | Optimal dimension using widget's optimal width and height.
    `static OptimalDimension` | `OPTIMAL_DIMENSION_Y` | Optimal dimension using widget's optimal height.

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `OptimalDimension()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `computeOptimalSize​(Widget widget, int availableWidth, int availableHeight, Size optimalSize)` | Computes the optimal size of a widget.
    `boolean` | `equals​(Object obj)` | Indicates whether some other object is "equal to" this one.
    `void` | `getAvailableSize​(Widget widget, int availableWidth, int availableHeight, Size availableSize)` | Gets the available size for a widget.
    `int` | `hashCode()` | Returns a hash code value for the object.
    `void` | `layOut​(Widget widget, Rectangle bounds)` | Lays out a widget.

    - ### Methods inherited from class java.lang.Object

      `clone, getClass, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### OPTIMAL_DIMENSION_XY

          public static final OptimalDimension OPTIMAL_DIMENSION_XY

      Optimal dimension using widget's optimal width and height.

    - #### OPTIMAL_DIMENSION_X

          public static final OptimalDimension OPTIMAL_DIMENSION_X

      Optimal dimension using widget's optimal width.

    - #### OPTIMAL_DIMENSION_Y

          public static final OptimalDimension OPTIMAL_DIMENSION_Y

      Optimal dimension using widget's optimal height.

  - ### Constructor Detail

    - #### OptimalDimension

          public OptimalDimension()

  - ### Method Detail

    - #### getAvailableSize

          public void getAvailableSize​(Widget widget,
                                       int availableWidth,
                                       int availableHeight,
                                       Size availableSize)

      Description copied from interface: `Dimension`
      Gets the available size for a widget.

      The given available size is the available width and height minus the outlines.

      The given size is updated by this method to set the available size for this dimension.

      Specified by:
        `getAvailableSize` in interface `Dimension`
      Parameters:
        `widget` - the widget.
        `availableWidth` - the available width.
        `availableHeight` - the available height.
        `availableSize` - the available size.

    - #### computeOptimalSize

          public void computeOptimalSize​(Widget widget,
                                         int availableWidth,
                                         int availableHeight,
                                         Size optimalSize)

      Description copied from interface: `Dimension`
      Computes the optimal size of a widget.

      The given optimal size is the optimal size of the widget considering the available size.

      The given size is updated by this method to set the optimal size for this dimension.

      Specified by:
        `computeOptimalSize` in interface `Dimension`
      Parameters:
        `widget` - the widget.
        `availableWidth` - the available width.
        `availableHeight` - the available height.
        `optimalSize` - the optimal size.

    - #### layOut

          public void layOut​(Widget widget,
                             Rectangle bounds)

      Description copied from interface: `Dimension`
      Lays out a widget.

      The style of the widget must be set before (not `null`).

      This dimension is applied to compute the widget bounds and align the widget in the given bounds. The given rectangle is updated with the updated bounds.

      Specified by:
        `layOut` in interface `Dimension`
      Parameters:
        `widget` - the widget.
        `bounds` - the bounds of the widget.

    - #### equals

          public boolean equals​(@Nullable
                                Object obj)

      Description copied from class: `Object`
      Indicates whether some other object is "equal to" this one.

      The `equals` method implements an equivalence relation on non-null object references:

      - It is reflexive: for any non-null reference value `x`, `x.equals(x)` should return `true`.
      - It is symmetric: for any non-null reference values `x` and `y`, `x.equals(y)` should return `true` if and only if `y.equals(x)` returns `true`.
      - It is transitive: for any non-null reference values `x`, `y`, and `z`, if `x.equals(y)` returns `true` and `y.equals(z)` returns `true`, then `x.equals(z)` should return `true`.
      - It is consistent: for any non-null reference values `x` and `y`, multiple invocations of `x.equals(y)` consistently return `true` or consistently return `false`, provided no information used in `equals` comparisons on the objects is modified.
      - For any non-null reference value `x`, `x.equals(null)` should return `false`.

      The `equals` method for class `Object` implements the most discriminating possible equivalence relation on objects; that is, for any non-null reference values `x` and `y`, this method returns `true` if and only if `x` and `y` refer to the same object (`x == y` has the value `true`).

      Note that it is generally necessary to override the `hashCode` method whenever this method is overridden, so as to maintain the general contract for the `hashCode` method, which states that equal objects must have equal hash codes.

      Specified by:
        `equals` in interface `Dimension`
      Overrides:
        `equals` in class `Object`
      Parameters:
        `obj` - the reference object with which to compare.
      Returns:
        `true` if this object is the same as the obj argument; `false` otherwise.
      See Also:
        `Object.hashCode()`, `HashMap`

    - #### hashCode

          public int hashCode()

      Description copied from class: `Object`
      Returns a hash code value for the object. This method is supported for the benefit of hash tables such as those provided by `HashMap`.

      The general contract of `hashCode` is:

      - Whenever it is invoked on the same object more than once during an execution of a Java application, the `hashCode` method must consistently return the same integer, provided no information used in `equals` comparisons on the object is modified. This integer need not remain consistent from one execution of an application to another execution of the same application.
      - If two objects are equal according to the `equals(Object)` method, then calling the `hashCode` method on each of the two objects must produce the same integer result.
      - It is not required that if two objects are unequal according to the `Object.equals(java.lang.Object)` method, then calling the `hashCode` method on each of the two objects must produce distinct integer results. However, the programmer should be aware that producing distinct integer results for unequal objects may improve the performance of hash tables.

      As much as is reasonably practical, the hashCode method defined by class `Object` does return distinct integers for distinct objects. (This is typically implemented by converting the internal address of the object into an integer, but this implementation technique is not required by the JavaTM programming language.)

      Specified by:
        `hashCode` in interface `Dimension`
      Overrides:
        `hashCode` in class `Object`
      Returns:
        a hash code value for this object.
      See Also:
        `Object.equals(java.lang.Object)`, `System.identityHashCode(java.lang.Object)`